#!/usr/bin/env python
# -*- coding:utf-8 -*-


# ############################################################################
#  license :
# ============================================================================
#
#  File :        SRinfo.py
#
#  Project :     TANGO Device Server
#
# This file is part of Tango device class.
# 
# Tango is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# Tango is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with Tango.  If not, see <http://www.gnu.org/licenses/>.
# 
#
#  $Author :      claudio.scafuri$
#
#  $Revision :    $
#
#  $Date :        $
#
#  $HeadUrl :     $
# ============================================================================
#            This file is generated by POGO
#     (Program Obviously used to Generate tango Object)
# ############################################################################

__all__ = ["SRinfo", "SRinfoClass", "main"]

__docformat__ = 'restructuredtext'

import PyTango
import sys
# Add additional import
#----- PROTECTED REGION ID(SRinfo.additionnal_import) ENABLED START -----#
import datetime
#----- PROTECTED REGION END -----#	//	SRinfo.additionnal_import

# Device States Description
# ON : can determine the top-up status
# FAULT : no relaiable dat is available data
# INIT : device not fully functional :failed to import some device proxy


class SRinfo (PyTango.Device_4Impl):
    """class for collectiong and distributing Storage Ring infromation for external users (beamlines, general public).
    Synthesisezs also some bitmaks for compatibility with old BCS protocol"""
    
    # -------- Add you global variables here --------------------------
    #----- PROTECTED REGION ID(SRinfo.global_variables) ENABLED START -----#

    #----- PROTECTED REGION END -----#	//	SRinfo.global_variables

    def __init__(self, cl, name):
        PyTango.Device_4Impl.__init__(self,cl,name)
        self.debug_stream("In __init__()")
        SRinfo.init_device(self)
        #----- PROTECTED REGION ID(SRinfo.__init__) ENABLED START -----#
        
        #----- PROTECTED REGION END -----#	//	SRinfo.__init__
        
    def delete_device(self):
        self.debug_stream("In delete_device()")
        #----- PROTECTED REGION ID(SRinfo.delete_device) ENABLED START -----#
        
        #----- PROTECTED REGION END -----#	//	SRinfo.delete_device

    def init_device(self):
        self.debug_stream("In init_device()")
        self.get_device_properties(self.get_device_class())
        self.attr_BeamON_read = False
        self.attr_Topupbits_read = [False]
        # ----- PROTECTED REGION ID(SRinfo.init_device) ENABLED START -----#
        self.set_state(PyTango.DevState.INIT)
        self.get_device_properties(self.get_device_class())
        self._last_read_time = datetime.datetime.now()
        try:
            self._topup = PyTango.DeviceProxy(self.Topudevice)
            self._dcct = PyTango.DeviceProxy(self.Dcctdevice)
            self._machine_status = PyTango.AttributeProxy(self.MachineStatus)
            self.set_state(PyTango.DevState.ON)
            self.set_status('SRinfo ON')
        except PyTango.DevFailed :
            self.error_stream("init_device(): creation of DeviceProxies failed")
            self.set_status('creation of DeviceProxies failed')
            self.set_state(PyTango.DevState.FAULT)

        #----- PROTECTED REGION END -----#	//	SRinfo.init_device

    def always_executed_hook(self):
        self.debug_stream("In always_excuted_hook()")
        #----- PROTECTED REGION ID(SRinfo.always_executed_hook) ENABLED START -----#
        
        #----- PROTECTED REGION END -----#	//	SRinfo.always_executed_hook

    # -------------------------------------------------------------------------
    #    SRinfo read/write attribute methods
    # -------------------------------------------------------------------------
    
    def read_BeamON(self, attr):
        self.debug_stream("In read_BeamON()")
        #----- PROTECTED REGION ID(SRinfo.BeamON_read) ENABLED START -----#
        attr.set_value(self.attr_BeamON_read)
        
        #----- PROTECTED REGION END -----#	//	SRinfo.BeamON_read
        
    def is_BeamON_allowed(self, attr):
        self.debug_stream("In is_BeamON_allowed()")
        if attr==PyTango.AttReqType.READ_REQ:
            state_ok = not(self.get_state() in [PyTango.DevState.FAULT])
        else:
            state_ok = not(self.get_state() in [])
        #----- PROTECTED REGION ID(SRinfo.is_BeamON_allowed) ENABLED START -----#
        
        #----- PROTECTED REGION END -----#	//	SRinfo.is_BeamON_allowed
        return state_ok
        
    def read_Topupbits(self, attr):
        self.debug_stream("In read_Topupbits()")
        #----- PROTECTED REGION ID(SRinfo.Topupbits_read) ENABLED START -----#
        attr.set_value(self.attr_Topupbits_read,5)
        
        #----- PROTECTED REGION END -----#	//	SRinfo.Topupbits_read
        
    def is_Topupbits_allowed(self, attr):
        self.debug_stream("In is_Topupbits_allowed()")
        if attr==PyTango.AttReqType.READ_REQ:
            state_ok = not(self.get_state() in [PyTango.DevState.FAULT])
        else:
            state_ok = not(self.get_state() in [])
        #----- PROTECTED REGION ID(SRinfo.is_Topupbits_allowed) ENABLED START -----#
        
        #----- PROTECTED REGION END -----#	//	SRinfo.is_Topupbits_allowed
        return state_ok
        
    
    
            
    def read_attr_hardware(self, data):
        self.debug_stream("In read_attr_hardware()")
        #----- PROTECTED REGION ID(SRinfo.read_attr_hardware) ENABLED START -----#
        now = datetime.datetime.now()
        deltaT = now - self._last_read_time
        deltamilli = deltaT.seconds * 1000 + deltaT.microseconds / 10000
        if deltamilli <= self.ReadInterval:
            return
        self._last_read_time = now  # record time value for next read time comparison

        if self.get_state() == PyTango.DevState.FAULT:
            return  # no update of faulty or non initialized device
        try:
            att = self._topup.read_attribute('State')
            if self.get_state() != PyTango.DevState.INIT:
                self.set_state(PyTango.DevState.ON)
            self._topupstat = att.value
            self.set_status('topup state read OK')
            if self._topupstat==PyTango.DevState.OFF:
                self.attr_Topupbits_read=[True,False,False,False,False]
            if self._topupstat == PyTango.DevState.ON:
                self.attr_Topupbits_read = [False, True, False, False, False]
            if self._topupstat == PyTango.DevState.ALARM:
                self.attr_Topupbits_read = [False, False, True, False, False]
            if self._topupstat == PyTango.DevState.RUNNING:
                self.attr_Topupbits_read = [False, False, False, True, False]
            if self._topupstat == PyTango.DevState.FAULT:
                self.attr_Topupbits_read = [False, False, False, False, True]

        except PyTango.DevFailed :
            if self.get_state() != PyTango.DevState.INIT:
                self.set_state(PyTango.DevState.UNKNOWN)
            self.set_status('failed to read top-up status')
            self._topupstat = PyTango.DevState.FAULT
            self.attr_Topupbits_read = [False, False, False, False, True]
            self.error_stream("failed to read top-up status")
            return
        try:
            curr = self._dcct.read_attribute('Current').value
            machine_st = self._machine_status.read().value
            self.set_status('topup state read OK,  SR current read OK,')
            curr_ok = (curr >= self.BeamONlowThresold)
            #topup_ok = (self._topupstat == PyTango.DevState.ON or self._topupstat == PyTango.DevState.RUNNING or self._topupstat == PyTango.DevState.ALARM)
            st_ok = (machine_st == "User Dedicated")
            if curr_ok and st_ok:
                self.attr_BeamON_read = True
            else:
                self.attr_BeamON_read = False
            # push event??
        except PyTango.DevFailed :
            self.set_status('failed to read SR current')
            #self.attr_BeamON_read = False
            self.error_stream("failed to read SR current")
        #----- PROTECTED REGION END -----#	//	SRinfo.read_attr_hardware


    # -------------------------------------------------------------------------
    #    SRinfo command methods
    # -------------------------------------------------------------------------
    

    #----- PROTECTED REGION ID(SRinfo.programmer_methods) ENABLED START -----#
    
    #----- PROTECTED REGION END -----#	//	SRinfo.programmer_methods

class SRinfoClass(PyTango.DeviceClass):
    # -------- Add you global class variables here --------------------------
    #----- PROTECTED REGION ID(SRinfo.global_class_variables) ENABLED START -----#
    
    #----- PROTECTED REGION END -----#	//	SRinfo.global_class_variables


    #    Class Properties
    class_property_list = {
        }


    #    Device Properties
    device_property_list = {
        'Topudevice':
            [PyTango.DevString, 
            "the topup device",
            ["tango://tom:20000/sr/feedback/topup"] ],
        'Dcctdevice':
            [PyTango.DevString, 
            "name of tango device for reading SR current",
            ["tango://tom:20000/sr/diagnostics/DCCT_S4"] ],
        'BeamONlowThresold':
            [PyTango.DevDouble, 
            "threshold value of SR current for switching beamON to false.\nValue in [mA]",
            [20]],
        'ReadInterval':
            [PyTango.DevULong, 
            "interval  between two field readings, in milliseconds",
            [2000]],
        'MachineStatus':
            [PyTango.DevString, 
            "Name of device/attrbute for reading the the global sttaus of the storage ring.\nThe value of the property is set manually by the control room operator.",
            ["tango://tom:20000/elettra/status/userstatus/machinestatus"] ],
        }


    #    Command definitions
    cmd_list = {
        }


    #    Attribute definitions
    attr_list = {
        'BeamON':
            [[PyTango.DevBoolean,
            PyTango.SCALAR,
            PyTango.READ],
            {
                'label': "beam on for users",
                'description': "True when beamline users can perfom experiments",
            } ],
        'Topupbits':
            [[PyTango.DevBoolean,
            PyTango.SPECTRUM,
            PyTango.READ, 5],
            {
                'label': "top up bitmask",
                'description': "Bits:\n0 OFF\n1 ON\n2 ALARM\n3 RUNNING\n4 FAULT",
                'Polling period': "2000",
            } ],
        }


def main():
    try:
        py = PyTango.Util(sys.argv)
        py.add_class(SRinfoClass, SRinfo, 'SRinfo')
        #----- PROTECTED REGION ID(SRinfo.add_classes) ENABLED START -----#
        
        #----- PROTECTED REGION END -----#	//	SRinfo.add_classes

        U = PyTango.Util.instance()
        U.server_init()
        U.server_run()

    except PyTango.DevFailed as e:
        print(('-------> Received a DevFailed exception:', e))
    except Exception as e:
        print(('-------> An unforeseen exception occured....', e))

if __name__ == '__main__':
    main()
